function injectScript(pluginName, pluginDesc = '', pluginParam = {}) {
  try {
    if (PluginManager._scripts.contains(pluginName)) return;

    $plugins.push({
      "name": pluginName,
      "status": true,
      "description": pluginDesc,
      "parameters": pluginParam
    })
    PluginManager.setParameters.call(PluginManager, pluginName, pluginParam);
    PluginManager.loadScript.call(PluginManager, Utils.RPGMAKER_NAME === 'MZ' ? pluginName : `${pluginName}.js`);
    PluginManager._scripts.push(pluginName);
  } catch (e) {}
}

function injectIrina() {
  injectScript('Irina_PerformanceUpgrade', '<PerformanceUpgrade> for RPG Maker MV version 1.6.2.', {
    "AnimationHue": "true",
    "BlurMenuBackground": "false",
    "BlurIntensity": "0.5",
    "CacheTextColors": "true",
    "EnemyHue": "true",
    "PixiContainerFlush": "true",
    "SkipUnnecessarySnapshots": "true"
  });
}

function injectCheatMenu() {
  injectScript('Cheat_Menu');
}

function injectInput(
  keyboard = {
    enabled: false
  }, joystick = {
    enabled: false,
    keyNum: 4
  }
) {

  injectScript('layer');
  if (keyboard.enabled) {
    injectScript('hodgef/keyboard');
    injectScript('hodgef/init');
  }
  if (joystick.enabled) {
    injectScript('yoannmoinet/nipplejs');
    injectScript('yoannmoinet/init', '', {
      keyNum: joystick.keyNum
    });
  }
}

function injectPluginFix() {
  injectScript('pluginfix');
}